﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

namespace PropertyGridDefaultEditorsCase
{
    public class ViewModel
    {
       public CustomObject PropGridObject { get; set; }

       public ViewModel()
        {
            PropGridObject = new CustomObject()
            {
                Boolean = true,
                Brush = new SolidColorBrush(Colors.Red),
                Color = Colors.Blue,
                Date = DateTime.Today,
                NullableDate = null,
                FontFamily = new FontFamily("Calibri"),
                FontStretch = FontStretch.FromOpenTypeStretch(5),
                FontStyle = FontStyles.Italic,
                FontWeight = FontWeights.Bold,
                String = "This is a String"
            };

            PropGridObject.NestedType = new List<NestedType>()
            {
                new NestedType() { Double = 1.234, Int = 5 }
            };
        }
    }

    public class CustomObject
    {
        public DateTime Date { get; set; }
        public DateTime? NullableDate { get; set; }
        public Color Color { get; set; }
        public Brush Brush { get; set; }
        public bool Boolean { get; set; }
        public FontFamily FontFamily { get; set; }
        public FontWeight FontWeight { get; set; }
        public FontStyle FontStyle { get; set; }
        public FontStretch FontStretch { get; set; }
        public string String { get; set; }
        public List<NestedType> NestedType { get; set; }
    }

    public class NestedType
    {
        public int Int { get; set; }
        public double Double { get; set; }        
    }
}
